<template>
  <div>
    <!--<template>
      <hsc-window-style-white>
        <hsc-window
          style=" z-index:2000"
          :resizable="true"
          :isScrollable="true"
          :minHeight="300"
          :maxHeight="500"
          :minWidth="300"
          :maxWidth="400"
          title="Viewer Objects"
          :width="400"
          :height="300"
        >
          <json-view :data="$data" />
        </hsc-window>
      </hsc-window-style-white>
    </template>-->
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>{{ textoIndicadorBreadCrumbs }}</strong>
    </div>
    <div class="cotm">
      <div class="tmod">
        <strong>Gestionar Protocolos</strong>
      </div>
      <div class="supSec">Gestiona los Protocolos o Crea uno Nuevo</div>
    </div>
    <div class="pl-10 pr-10 contSecc lighten-5">
      <v-tabs
        class="custom-tab"
        height="46"
        color="white"
        active-class="active-tab"
        grow
        background-color="#f2f2f2"
        show-arrows
        v-model="indexGrupoProtocoloSelected"
      >
        <v-tabs-slider color="primary"></v-tabs-slider>
        <v-tab
          v-for="(grupoProtocolo, indexGrupoProtocolo) in gruposProtocolos"
          :key="indexGrupoProtocolo"
        >
          <div>{{ grupoProtocolo.nombre_grupo }}</div>
        </v-tab>

        <v-tab-item
          class="pt-4"
          v-for="(grupoProtocolo, indexGrupoProtocolo) in gruposProtocolos"
          :key="indexGrupoProtocolo"
        >
          <v-text-field
            v-model.trim="grupoProtocolo.search_protocolo"
            class="float-right pt-0 mt-0"
            clearable
            label="Buscar..."
            type="text"
          >
            <template v-slot:append>
              <v-tooltip bottom>
                <template v-slot:activator="{ on }">
                  <v-icon v-on="on">mdi-card-search-outline</v-icon>
                </template>
                Buscar
              </v-tooltip>
            </template>
          </v-text-field>
          <div class="titSec">Protocolos {{ grupoProtocolo.nombre_grupo }}</div>
          <v-sheet width="100%" class="overflow-y-auto CardScroll">
            <v-row>
              <v-col
                v-for="(itemProtocolo, indexProtocolo) in protocolosFiltered(
                  indexGrupoProtocolo
                )"
                :key="indexProtocolo"
                v-show="itemProtocolo.show"
                :xs="12"
                :sm="12"
                :md="6"
                :lg="3"
              >
                <v-card class="generalCard pa-4">
                  <div>
                    <v-btn x-small class="float-left" text icon>
                      <v-img
                        @click="
                          dialogDelete = true;
                          protocoloToRemove = itemProtocolo;
                        "
                        :contain="true"
                        :aspect-ratio="1"
                        position="center"
                        src="@/assets/img/delete.svg"
                        class="white--text align-end"
                      ></v-img>
                    </v-btn>
                    <v-btn
                      :to="itemProtocolo.to"
                      x-small
                      class="float-right"
                      text
                      icon
                    >
                      <v-img
                        :contain="true"
                        :aspect-ratio="1"
                        position="center"
                        src="@/assets/img/icoEditar.svg"
                        class="white--text align-end"
                      ></v-img>
                    </v-btn>
                  </div>
                  <v-card-text>
                    <div class="cardFranqName cardFranqNameLine">
                      {{ itemProtocolo.nego }}
                    </div>
                    <div class="cardCreacion">
                      <div>
                        Fecha de creación:
                        {{
                          moment(itemProtocolo.fecha_inicio).format(
                            "DD / MM / YYYY"
                          )
                        }}
                      </div>
                      <div>
                        Creado por:
                        {{ itemProtocolo.nomusu }}
                      </div>
                    </div>
                    <div
                      class="cardModificacion"
                      v-if="itemProtocolo.fechaModificacion"
                    >
                      <div>
                        <b>
                          Fecha de última modificación:
                          {{
                            moment(itemProtocolo.fechaModificacion).format(
                              "DD / MM / YYYY"
                            )
                          }}
                        </b>
                      </div>
                    </div>
                    <v-footer absolute class="CardCustomAction">
                      <v-row v-if="itemProtocolo.asignar">
                        <v-col :cols="12" :xl="6" class="text-left pa-0 pr-5">
                          Empleado
                          <span class="tRojo">*</span>
                          <v-text-field
                            v-model.trim="itemProtocolo.noEmpleado"
                            class="pt-0 mt-0"
                            clearable
                            placeholder="Empleado"
                            type="text"
                            color="primary"
                            prepend-inner-icon="mdi-account"
                          >
                          </v-text-field>
                        </v-col>
                        <v-col class="text-left pa-0" :cols="12" :xl="6">
                          Fecha de validación
                          <span class="tRojo">*</span>
                          <v-menu
                            v-model="itemProtocolo.showDate"
                            ref="showDate"
                            :close-on-content-click="false"
                            transition="scale-transition"
                            offset-y
                            min-width="290px"
                          >
                            <template v-slot:activator="{ on }">
                              <v-text-field
                                class="pa-0 ma-0"
                                v-model="itemProtocolo.fechaAsignacion"
                                placeholder="Fecha de validación"
                                prepend-inner-icon="mdi-calendar-month"
                                readonly
                                clearable
                                v-on="on"
                              ></v-text-field>
                            </template>
                            <v-date-picker
                              locale="es-mx"
                              color="primary"
                              v-model="itemProtocolo.fechaAsignacion"
                              no-title
                              scrollable
                              @input="itemProtocolo.showDate = false"
                            >
                            </v-date-picker>
                          </v-menu>
                        </v-col>
                        <v-row justify="center" class="mb-3">
                          <v-btn
                            @click="
                              itemProtocolo.asignar = !itemProtocolo.asignar
                            "
                            class="mr-2"
                            dark
                            small
                            depressed
                            color="secundary"
                            >Cancelar</v-btn
                          >
                          <v-btn
                            color="primary"
                            small
                            depressed
                            :class="[
                              {
                                desac: !itemProtocolo.fechaAsignacion
                              },
                              {
                                desac:
                                  !itemProtocolo.noEmpleado ||
                                  itemProtocolo.noEmpleado === ''
                              }
                            ]"
                            @click="openConfirmationAsignacion(itemProtocolo)"
                            >Aceptar</v-btn
                          >
                        </v-row>
                      </v-row>
                      <v-row v-if="!itemProtocolo.asignar">
                        <v-col>
                          <v-btn
                            @click="
                              itemProtocolo.asignar = !itemProtocolo.asignar
                            "
                            class="ma-2"
                            dark
                            tile
                            depressed
                            color="primary"
                            >Validar Protocolo</v-btn
                          >
                        </v-col>
                      </v-row>
                    </v-footer>
                  </v-card-text>
                </v-card>
              </v-col>
            </v-row>
          </v-sheet>
        </v-tab-item>
      </v-tabs>

      <v-row class="mt-6">
        <v-col
          :key="cardAdd.title"
          :cols="12"
          :xs="12"
          :sm="6"
          :md="5"
          :lg="4"
          :xl="3"
        >
          <v-card
            :to="cardAdd.to"
            :color="cardAdd.color"
            class="generalCard pa-4"
          >
            <div
              class="cardTitle cardFranqNameWhiteLine text-center white--text pb-2 pa-0"
              v-text="cardAdd.title"
            ></div>
            <v-avatar size="60" class="pa-2" tile>
              <v-img
                :contain="true"
                :aspect-ratio="1"
                position="center"
                :src="cardAdd.src"
                :lazy-src="cardAdd.src"
                class="white--text align-end"
              >
                <template v-slot:placeholder>
                  <v-row
                    class="fill-height ma-0"
                    align="center"
                    justify="center"
                  >
                    <v-progress-circular
                      indeterminate
                      color="grey lighten-5"
                    ></v-progress-circular>
                  </v-row>
                </template>
              </v-img>
            </v-avatar>
          </v-card>
        </v-col>
      </v-row>
    </div>
    <template>
      <v-dialog v-model="dialogDelete" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>¿Seguro que deseas eliminar este protocolo?</strong>
            </div>
          </v-card-title>
          <v-card-text></v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogDelete = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="deleteProtocolo"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="dialogAssing" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <div class="titModal">
              <strong>¿Seguro que deseas asignar este protocolo?</strong>
            </div>
          </v-card-title>
          <v-card-text>
            Al empleado
            <strong v-if="empleadoToAssign">{{
              empleadoToAssign.nombre_usuario
            }}</strong>
            <v-progress-circular
              class="float-right"
              v-if="isSearchingUser"
              indeterminate
              size="30"
              >buscando...</v-progress-circular
            >
          </v-card-text>
          <v-card-actions>
            <v-row justify="center" style="margin-right:0px">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="dialogAssing = false"
                >No, cancelar</v-btn
              >
              <v-btn
                class="ma-2"
                :class="[
                  { desac: isSearchingUser },
                  { desac: savingAssing },
                  { desac: !userValid }
                ]"
                depressed
                dark
                tile
                color="primary"
                @click="asignarProtocolo"
                >Si, continuar</v-btn
              >
            </v-row>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<style scoped></style>
<script>
import axios from "axios";
import router from "@/router";
import store from "@/store";
import moment from "moment";
import { format } from "path";
const axiosChecklist = store.state.axiosChecklist;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-Protocolos",
  data() {
    return {
      dialogDelete: false,
      dialogAssing: false,
      isSearchingUser: false,
      userValid: false,
      savingAssing: false,
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home"
          }
        },
        {
          text: "Modelo de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia"
          }
        },
        {
          text: "Protocolos",
          disabled: false,
          exact: true,
          to: {
            name: "modelo_franquicia_home_protocolos"
          }
        }
      ],
      cardAdd: {
        title: "Crear Protocolo",
        src: require("@/assets/img/masBlanco.svg"),
        description: "Añade un nuevo protocolo.",
        to: {
          name: "modelo_franquicia_protocolos_nuevo",
          params: {
            tipo_protocolo: this.$route.params.tipo_protocolo
          }
        },
        color: "#494949"
      },
      protocoloToRemove: {},
      protocoloToAssing: {},
      empleadoToAssign: {
        nombre_usuario: null,
        id_usuario: null,
        id_ceco: null
      },
      metadata: {},
      indexGrupoProtocoloSelected: 0,
      gruposProtocolos: [
        {
          id_grupo: null,
          nombre_grupo: "Activos",
          search_protocolo: null,
          id_ambiente: 1,
          protocolos: []
        },
        {
          id_grupo: null,
          nombre_grupo: "Revisión",
          search_protocolo: null,
          id_ambiente: 2,
          protocolos: []
        }
      ]
    };
  },
  computed: {
    textoIndicadorBreadCrumbs() {
      let text;
      const tipoProtocolo = this.$route.params.tipo_protocolo;
      if (tipoProtocolo === "aseguramiento-calidad") {
        text = "Certificación de Calidad";
      } else if (tipoProtocolo === "infraestructura") {
        text = "Infraestructura";
      }
      return text;
    },
    serviceCommons() {
      return serviceCommons;
    },
    moment() {
      return moment;
    }
  },
  methods: {
    initValues() {
      const tipoProtocolo = this.$route.params.tipo_protocolo;
      if (tipoProtocolo) {
        if (tipoProtocolo === "aseguramiento-calidad") {
          this.breadcrumbs.push({
            text: "Certificación de Calidad",
            disabled: true
          });
          this.setIdGrupoProtocolos(1);
        } else if (tipoProtocolo === "infraestructura") {
          this.breadcrumbs.push({
            text: "Infraestructura",
            disabled: true
          });
          this.setIdGrupoProtocolos(2);
        } else {
          router.push({ name: "modelo_franquicia_protocolos_404" });
        }
      }
    },
    setIdGrupoProtocolos(id_tipo_protocolo) {
      this.gruposProtocolos = this.gruposProtocolos.map(
        (itemGrupoProtocolo) => {
          if (id_tipo_protocolo === 1) {
            if (itemGrupoProtocolo.id_ambiente === 1) {
              itemGrupoProtocolo.id_grupo = 323;
            }
            if (itemGrupoProtocolo.id_ambiente === 2) {
              itemGrupoProtocolo.id_grupo = 326;
            }
          } else {
            if (itemGrupoProtocolo.id_ambiente === 1) {
              itemGrupoProtocolo.id_grupo = 321;
            }
            if (itemGrupoProtocolo.id_ambiente === 2) {
              itemGrupoProtocolo.id_grupo = 327;
            }
          }
          return itemGrupoProtocolo;
        }
      );
    },
    protocolosFiltered(indexGrupoProtocolo) {
      let grupoProtocolos = this.gruposProtocolos[indexGrupoProtocolo];
      return grupoProtocolos.protocolos.filter((itemProtocolo) => {
        if (
          grupoProtocolos.search_protocolo &&
          grupoProtocolos.search_protocolo !== ""
        ) {
          if (
            itemProtocolo.nombreCheck
              .toLowerCase()
              .includes(grupoProtocolos.search_protocolo.toLowerCase())
          ) {
            itemProtocolo.show = false;
          }
          return itemProtocolo;
        } else {
          itemProtocolo.show = true;
          return itemProtocolo;
        }
      });
    },
    openConfirmationAsignacion(protocolo) {
      this.protocoloToAssing = protocolo;
      this.dialogAssing = true;
      this.isSearchingUser = true;
      const self = this;
      axios
        .get("/usuario/secure/get/" + protocolo.noEmpleado)
        .then((response) => {
          const data = response.data;
          if (data.status_code === 200) {
            if (data.track_code && data.track_code === 3006) {
              self.empleadoToAssign.nombre_usuario = "Usuario no encontrado";
              self.userValid = false;
            } else {
              self.empleadoToAssign = data.data;
              self.empleadoToAssign.nombre_usuario = self.serviceCommons.titleCase(
                data.data.nombre_usuario
              );
              self.userValid = true;
            }
          } else {
            self.empleadoToAssign.nombre_usuario = "Usuario no encontrado";
            self.userValid = false;
          }
        })
        .catch((error) => {
          self.empleadoToAssign.nombre_usuario = "Usuario no encontrado";
          self.userValid = false;
          console.log(error);
        })
        .finally(function() {
          self.isSearchingUser = false;
        });
    },
    asignarProtocolo() {
      const self = this;
      this.savingAssing = true;
      axiosChecklist
        .post(
          "/catalogosAdmService/postAsignaValidacion.json?setActivo=1&idCeco=999999999&idVersion=" +
            this.protocoloToAssing.idtab +
            "&idUsu=" +
            this.protocoloToAssing.noEmpleado +
            "&fechaLiberacion=" +
            this.protocoloToAssing.fechaAsignacion
        )
        .then((response) => {
          if (response.data.response) {
            self.dialogAssing = false;
            self.protocoloToAssing.asignar = false;
            self.protocoloToAssing.noEmpleado = null;
            self.protocoloToAssing.fechaAsignacion = null;
            self.empleadoToAssign = null;
            self.protocoloToAssing = null;
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {
          self.savingAssing = false;
        });
    },
    getProtocolos() {
      const self = this;
      this.gruposProtocolos.forEach((itemGrupoProtocolo) => {
        let urlGetProtocolos;
        if (itemGrupoProtocolo.id_ambiente === 1) {
          urlGetProtocolos =
            "/consultaChecklistAdminService/getGrupoProtocolosActivos.json?idGrupo=" +
            itemGrupoProtocolo.id_grupo;
        } else {
          urlGetProtocolos =
            "/consultaChecklistAdminService/getGrupoProtocolosRevision.json?idGrupo=" +
            itemGrupoProtocolo.id_grupo;
        }
        axiosChecklist
          .get(urlGetProtocolos)
          .then((response) => {
            if (response) {
              let data = response.data;
              if (data) {
                data = self.setProtocolos(data, itemGrupoProtocolo.id_ambiente);
                itemGrupoProtocolo.protocolos = data;
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function() {});
      });
    },
    setProtocolos(data, id_ambiente) {
      if (data) {
        data.forEach((itemProtocolo) => {
          itemProtocolo.asignar = false;
          itemProtocolo.noEmpleado = "";
          itemProtocolo.fechaAsignacion = null;
          itemProtocolo.showDate = false;
          itemProtocolo.to = {
            name: "modelo_franquicia_protocolos_edicion",
            params: {
              protocolo: this.serviceCommons.objectToBase64({
                id_tab: itemProtocolo.idtab,
                id_ambiente: id_ambiente
              })
            }
          };
        });
        return data;
      }
    },
    deleteProtocolo() {
      const self = this;
      let urlDeleteProtocolo;
      if (
        this.gruposProtocolos[this.indexGrupoProtocoloSelected].id_ambiente ===
        1
      ) {
        urlDeleteProtocolo =
          "catalogosAdmService/updateProtocoloProductivoById.json?idProtocolo=" +
          self.protocoloToRemove.idtab +
          "&status=0";
      } else {
        urlDeleteProtocolo =
          "catalogosAdmService/updateProtocoloRevisionById.json?idProtocolo=" +
          self.protocoloToRemove.idtab +
          "&status=0";
      }
      axiosChecklist
        .get(urlDeleteProtocolo)
        .then((response) => {
          if (response.data.response) {
            self.gruposProtocolos[
              self.indexGrupoProtocoloSelected
            ].protocolos = self.gruposProtocolos[
              self.indexGrupoProtocoloSelected
            ].protocolos.filter(
              (itemProtocolo) =>
                itemProtocolo.idtab !== self.protocoloToRemove.idtab
            );
            this.dialogDelete = false;
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function() {});
    }
  },
  created() {
    this.initValues();
    this.getProtocolos();
  }
};
</script>
